		; Assemblerfile generated AUTO_DIS.EXE
		; Program developed by Ruud Baltissen
		
		; Labels and comments manually entered 
		; by Rob van Oostenbrugge
		; syntax altered to AS65 assembler.
		 
		; MAIN PROGRAM OF THE PRINTER MONITOR
		; ELEKTOR JUNIOR COMPUTER BOOK 4
		;
		; assemble with TASM tasm -65  -g3 -s -l  -c -fff "$(FILE_NAME)" "$(NAME_PART).bin"  "$(NAME_PART).lst"  -s "$(NAME_PART).sym"
		;

pcl		.equ	$EF		
pch		.equ	$F0
preg	.equ	$F1
spuser	.equ	$F2		
acc		.equ	$F3
yreg	.equ	$F4
xreg	.equ	$F5

inl		.equ	$F8
inh		.equ	$F9
pointl	.equ	$FA
pointh	.equ	$FB
cnthl	.equ	$1A5C
cnthh	.equ	$1A5D
timl	.equ $1A5E
timh	.equ $1A5F

tempb	.equ $1A61
cha		.equ	$1A62
paral	.equ	$1A63
parah	.equ	$1A64
parbl	.equ	$1A65
parbh	.equ	$1A66
prtemp	.equ	$1A67

sal		.equ	$1A70
sah		.equ	$1A71
eal		.equ	$1A72
eah		.equ	$1A73

nmi		.equ	$1A7A
brkt	.equ $1A7C

id		.equ	$1A79
pad 	.equ $1A80
pbd		.equ $1A82
cntl	.equ	$1A5A
cnth	.equ	$1A5B
padd	.equ	$1A81
pbdd	.equ	$1A83
stpbit	.equ	$1A59

dump 	.equ $09DF	; extern programma TM
rdtape	.equ $0B02	; extern programma TM


		.org $1000

initpr	cld				; Reset s.equence of the printer program
		sei				; IRQ line disabled
		lda	#$67	
		sta	pbd			; PBD: 01100111
		lda	#$00
		sta	pad			; PAD: 00000000
		ldx	#$FE		; Reset bit time counter
		stx	cntl
		inx
		stx	cnth		; (x=FF)
		txs				; Reset computer stackpointer
		stx	spuser		; Reset	user stackpointer	
		lda	#$7F	
		sta	padd		; PADD: 01111111
		sta	pbdd		; PBDD: 01111111
		ldx	#$02	
		stx	stpbit		; transmit node parity & one stopbit    
		lda	#$5F		; adl labjun  (in elektuur list: lda labjun) 	    
		sta	brkt		; Setup break vecor
		lda	#$10    	; adh labjun  (in elektor list: lda labjun/256) 	
		sta	brkt+1                                                      
		lda	#$CF    	; adl step	(in elektuur list: lda step) 	        
		sta	nmi     	; Setup step by step vector	                        
		lda	#$14    	; adh step  (in elektor list: lda step/256)      
		sta	nmi+1   	
		
strtbt	bit	pad     	; Wait for a startbit                                                    
		bmi	strtbt  	; en loop                                           
                                                   
		jsr	comtim		; Compute start bit time
		lsr	timh		; Devide by 2	
		ror	timl
		lda	timl
		sta	cnthl		; save half start bit time
		lda	timh		
		sta	cnthh
		ldx	#$08
		jsr	delhbt		; $1303
		jsr	recd		; get the rest of the character
		cmp	#$7F		; was it the rubout character ?
		bne	initpr		; ga terug naar af
  
labjun	jsr	junior		; Print JUNIOR
		jsr	crlf		; $11E8
		ldx	#$FF
		txs				; Reset stackpointer when a break occurs
		stx	spuser
resall	jsr	respar		; Reset parameter buffer
		jsr	resin		; Reset input buffer
readch	jsr	reccha		; Wait for a character

plu		cmp	#$2B		; + pluskey ?
		bne	minus
  		jsr	incpnt		; Increment current adres
		jsr	prbufs		; Open next cell
		jmp	resall		; $106A
  
minus	cmp	#$2D		; - minuskey ?
		bne	space
  		jsr	decpnt		; Decrement current adres
		jsr	prbufs		; Open previous cell
		jmp	resall		; $106A
  
space	cmp	#$20		; spacebar ?
		bne	pnt
		lda	inl			; Output the addres						
		sta	pointl		; in the input buffer
		lda	inh
		sta	pointh
		jsr	prbufs		; Open current cell
		jmp	resall		; $106A
  
pnt		cmp	#$2E		; dotkey ?
		bne	run			
  		lda	inl
		ldy	#$00
		sta	(pointl),y	; Store current data byte in memory
		jsr	incpnt		; $1213
		jsr	prbufs		; Open next cell
		jmp	resall		; $106A
  
run		cmp	#$52		; $10B2
		bne	lisst
		ldx	spuser		; Start program execution
		txs				; At the current display addres
		lda	pointh
		pha
		lda	pointl
		pha
		lda	preg
		pha
		ldx	xreg
		ldy	yreg
		lda	acc
		rti
  
lisst	cmp	#$4C		; original label "list" not accepted by as65
		bne	pc
  
		ldy	#$14
		jsr	messy		; ACC 
		lda	acc
		jsr	prbyt		; $128F
		ldy	#$1A
		jsr	messy		; Y 
		lda	yreg
		jsr	prbyt		; $128F
		ldy	#$20
		jsr	messy		; X
		lda	xreg
		jsr	prbyt		; $128F
		ldy	#$26
		jsr	messy		; PC
		lda	pch
		jsr	prbyt		; $128F
		lda	pcl
		jsr	prbyt		; $128F
		ldy	#$2C
		jsr	messy		; SP
		lda	#$01
		jsr	prbyt		; $128F
		lda	spuser
		jsr	prbyt		; $128F
		ldy	#$32
		jsr	messy		; PR
		jsr	showpr		; Print out flags
		ldy	#$38
		jsr	messy		; NV BDIZC ??
		jsr	prsp		; $11F3
		jmp	resall		; $106A
  
contin	jmp	gettap		; $111C , $11B0
  
pc		cmp	#$50		; $111F
		bne	matrix
  		lda	pcl			; Restore last program counter
		sta	pointl
		lda	pch
		sta	pointh
		jsr	prbufs		; Open current cell
		jmp	resall		; $106A
  
matrix	cmp	#$4D		; $1131
		bne	contin
  		ldy	#$52
		jsr	messy		; Hexdump
		jsr	inpar		; Read parameters
		bpl	matf
  
matd	jmp	labjun		; return if valid character
matf	sec				; Valid input parameters ?
		lda	parbl
		sbc	paral		; PARA < PARB ?
		lda	parbh
		sbc	parah
		bcc	matd
  
		jsr	crlf		; $11E8
		ldx	#$06
matg	jsr	prsp		; $1156 , $11F3
		dex
		bne	matg
  
		ldy	#$00		; reset column counter
math	tya				; $115E
		jsr	prnibl		; Output columns
		jsr	prsp		; $11F3
		jsr	prsp		; $11F3
		iny
		cpy	#$10		; Print columns 0...F
		bne	math
  
		lda	paral
		sta	pointl		; Setup matrix pointer
		lda	parah
		sta	pointh
matj	jsr	crlf		; $1177 , $11E8
		ldx	#$10
		lda	pointh
		jsr	prbyt		; Output current matrix addres
		lda	pointl
		jsr	prbyt		; $128F
		ldy	#$17
		jsr	me			; $11D9
matk	sec				; $118B
		lda	parbl		; Hexdump finished ?
		sbc	pointl
		lda	parbh
		sbc	pointh
		bcs	matl
 		jsr	crlf		; $11E8
		jmp	labjun		; Hexdump is finished
  
matl	ldy	#$00		; $119E
		lda	(pointl),y	; Fetch current data byte
		jsr	prbyt		; Output current data byte
		jsr	prsp		; $11F3
		jsr	incpnt		; $1213
		dex
		bne	matk
  		beq	matj
  
gettap	cmp	#$47		; $11B0
		bne	savid
		jsr	getid		; Read data froom tape spec. by id
		bmi	geterr		; Illegal character ?
  		jmp	resall		; Normal exit
  
geterr	jmp	labjun		; $11BC , $105F
  
savid	cmp	#$53		; $11BF
		bne	valnum		; No command key was depressed
  		jsr	said		; Store data on tape specified by the parameters
		bmi	geterr		; geterr ilegal parameter was entered
  		jmp	resall		; $106A
  
valnum	jsr	hexnum		; Hexnum input data to buffer
		bne	vna
  
		jmp	readch		; $1070
  
vna		jmp	resall		; $11D3 , $106A

		; SUBROUTINES OF THE PRINTER PROGRAM

messy	jsr	crlf		; Print a CR& LF

me		lda	mess,y		; Load characters
		cmp	#$03		; end of text character ?
		beq	mesend
  		jsr	prcha		; character to tty
		iny
		jmp	me			; $11D9

mesend	rts				; $11E7
		
		; crlf print carriage return & line feed
		; prsp print a space  

crlf	lda	#$0D		; $11E8
		jsr	prcha		; Output CR
		lda	#$0A

clend	jsr	prcha		; Output LF
		rts
  
prsp	lda	#$20		; $11F3
		jmp	clend		; Output a space

		; prbufs output addres and data
  
prbufs	jsr	crlf		; $11F8 , $11E8
		lda	pointh
		jsr	prbyt		; Output high order addr
		lda	pointl
		jsr	prbyt		; Output low order addr
		jsr	prsp		; $11F3
		ldy	#$00
		lda	(pointl),y	; Fetch data from memory
		jsr	prbyt		; $128F
		jsr	prsp		; $11F3
		rts

		; incpnt increment addres pointer by one

incpnt	inc	pointl		; $1213
		bne	ip
  		inc	pointh
ip		rts				; $1219

		; decpnt decrement addres pointer by one

decpnt	sec				; $121A		
		lda	pointl
		sbc	#$01
		sta	pointl
		lda	pointh
		sbc	#$00
		sta	pointh
		rts

		; showpr show the contents of the p register  

showpr	lda	preg		; $1228
		sta	prtemp
		ldx	#$08		; Bit counter

spra	asl	prtemp		; Shift out the bits
		bcc	sprb		; is it a 0 or 1 ?
		lda	#$01
		jsr	prnibl		; Print a "1"
		dex
		bne	spra		; All bits printed ?
		rts
  
sprb	lda	#$00		; 123D
		jsr	prnibl		; Print a "0"
		dex				
		bne	spra		; All bits printed ?	
  		rts

		; Junior print "junior"
		; Editor print "editor"
		; Asssem print "assembler"
  
junior	ldy	#$00		; $1246

jun		jsr	messy		; $11D6
		jsr	crlf		; $11E8
		rts
 
editor	ldy #$07		; $124F
  		jmp jun

assem 	ldy #$0E		; $1254 
  		jmp jun
  		
		; Reset subroutines

respar	ldy	#$00		; $1259
		sty	paral
		sty	parah
		sty	parbl
		sty	parbh
		rts
  
resin	ldy	#$00		; $1268
		sty	inl
		sty	inh
		rts

		; hexnum
		; convert an ascii char. to a hex nibble
  		; shift hex data nibble into buffer
  		; print "what?" if the character was not valid
  		; Return with Z=1, if valid character
  		; Return with N=1, if not valid character
  		
hexnum	jsr	ashett		; ascii hex conversion
		bmi	hnub		; Not valid ?
  		ldx	#$04		; Set nibble counter
hnua	asl	inl			
		rol	inh
		dex
		bne	hnua
  		ora	inl			; Nibble to input buffer
		sta	inl			
		ldy	#$00		; Set Z flag
		rts
  
hnub	ldy	#$46		; $1284
		jsr	messy		; "what?"
		jsr	crlf		; $11E8
		ldy	#$FF		; Set N flag
		rts

		; Convert a byte stored in accu to 
		; two ascii characters and print them
  
prbyt	pha				; Save byte
		lsr	a			; get upper nibble
		lsr	a
		lsr	a
		lsr	a
		jsr	nibasc		; Nibble to ascii conversion
		jsr	prcha		; Print upper nibble
		pla				; Get byte again

prnibl	and	#$0F		; Get lower nibble 
		jsr	nibasc		; $12A4
		jsr	prcha		; Print lower nibble
		rts

		; Convert a hex data nibble to an ascii character

nibasc	cmp	#$0A		; Number or letter ?
		clc
		bmi	na
		adc	#$07

na		adc	#$30		; $12AB	
		rts

		; Receive 1 ascii character from printer
		; return with ascii character in accu
		; save x register
		
  
reccha	bit	pad			; Wait for startbit
		bmi	reccha
		stx	tempb		; Save index x
		ldx	#$08		; Bit counter is 8
		jsr	delhbt		; Delay half bit time

reca	jsr	delbit		; Delay one bit time

recd	bit	pad			; one/zero check
		bpl	recb		; Branch if zero
  		sec				; Bit is "1"
		ror	cha			; Rotate carry into character
		dex				; setup for next bit
		bne	reca		; All bits read ?
  		jmp	recc		; $12D4
  	
recb	clc				; Bit is "0"
		ror	cha
		dex
		bne	reca
  
recc	jsr	delbit		; Wait for stop bit time
		lda	cha
		and	#$7F		; Bit 7 must be zero
		ldx	tempb		; Restore index x
		rts
		
		; Compute bit time
  
comtim	clc
		lda	cntl		; 16 bit add
		adc	#$01
		sta	cntl
		lda	cnth
		adc	#$00
		sta	cnth
		bit	pad			; Start bit finished ?
		bpl	comtim
  		lda	cntl		; Set up for
		sta	timl		; half bit time computation
		lda	cnth
		sta	timh
		rts

		; delbit delay 1 bit time 
		; delhbt delay 1/2 bit time
		
delhbt	lda	cnthl		; Fetch half bit time
		sta	timl
		lda	cnthh
		sta	timh
		jmp	cntdn		; Start with bit countdown
  
delbit	lda	cntl		; Fethc 1 bit time
		sta	timl
		lda	cnth
		sta	timh
cntdn	sec
		lda	timl		; 16 bit substraction
		sbc	#$01		; Count down
		sta	timl
		lda	timh
		sbc	#$00
		sta	timh
		nop				; .equalize 4 micro sec.
		nop
		bcs	cntdn		; count down finished ?
  		rts

		; Transmit an ascii character 
		; stored in accu to printer
  		; save index x
  		
prcha	stx	$1A60		; Save index x
		sta	cha
		lda	pbd
		and	#$FE		; Transmit start bit
		sta	pbd
		jsr	delbit		; Delay fo startbit
		ldx	#$07		; Set up for 7 databits
pra		lsr	cha			; Shift out character
		bcc	prc			; Branch if "0"
  		lda	pbd
		ora	#$01		; Output a log "1"
		sta	pbd
		
prb		jsr	delbit		; Delay 1 bit time
		dex				; Set up for next bit
		bne	pra			; All bits transmitted ?
  		ldx	stpbit		; x = amount of stopbits + 1

prd		lda	pbd
		ora	#$01		; First none parity
		sta	pbd			; and then 1 stop bit
		jsr	delbit		; $1312
		dex
		bne	prd
 		bit	pad			; test for break
		bpl	brktst
  		ldx	$1A60		; restore index x
		rts
  
brktst	bit	pad			; Key released
		bpl	brktst
  		jmp	(brkt)		; Jump to a user selectable vector
  
prc		lda	pbd			; $137C
		and	#$FE		; Output a log "0"
		sta	pbd
		jmp	prb			; $1354
		
		; inpar Parameter input of matrix
  
inpar	jsr	reccha		; Wait for a character
		cmp	#$2C		; Is it a colon ? ","
		beq	ipa
  		jsr	hexnum		; Fillup input buffer
		bmi	ipd			; Return if not valid
 		beq	inpar		; Else continue
  
ipa		lda	inl			; Input to parameter buffer
		sta	paral
		lda	inh
		sta	parah
		jsr	resin		; $1268
ipb		jsr	reccha		; $13A2 , $12AE
		cmp	#$0D
		beq	ipc
  		jsr	hexnum		; $126F
		bmi	ipd
  		beq	ipb
  
ipc		lda	inh			; 13B0
		sta	parbh
		lda	inl
		sta	parbl
		ldy	#$00
ipd		rts
  
 
mess	.byte $4A, $55, $4E, $49, $4F, $52, $03, $45	; JUNIOR.E
		.byte $44, $49, $54, $4F, $52, $03, $41, $53	; DITOR.AS
		.byte $53, $45, $4D, $03, $41, $43, $43, $3A	; SEM.ACC:
		.byte $20, $03, $59, $20, $20, $3A, $20, $03	;  .Y  : .
		.byte $58, $20, $20, $3A, $20, $03, $50, $43	; X  : .PC
		.byte $20, $3A, $20, $03, $53, $50, $20, $3A	;  : .SP :
		.byte $20, $03, $50, $52, $20, $3A, $20, $03	;  .PR : .
		.byte $20, $20, $20, $20, $20, $4E, $56, $20	;      NV
		.byte $42, $44, $49, $5A, $43, $03, $57, $48	; BDIZC.WH
		.byte $41, $54, $3F, $03, $52, $45, $41, $44	; AT?.READ
		.byte $59, $03, $48, $45, $58, $44, $55, $4D	; Y.HEXDUM
		.byte $50, $3A, $20, $03, $53, $41, $3A, $20	; P: .SA:
		.byte $03										; .
 

		; ashett = aschex
		; convert an ascii character to e hex data nibble
		; 1) return with converted hex number in accu
		; 2) N=1, if not valid hex number
		; 3) Z=1, if valid hex number

ashett	cmp	#$30		; Ignore 00...2F
		bmi	notvat
		cmp	#$3A
		bmi	valit
		cmp	#$41		; Ignore 3A...40
		bmi	notvat
		cmp	#$47		; Ignore 47...7F
		bmi	valit
  
notvat	ldy	#$FF		; Set N flag
		rts				; Error exit
  
valit	cmp	#$40		; Ascii hex conversion
		bmi	valt
 		clc
		adc	#$09

valt	and	#$0F		; $1438
		rts
  
said	jsr	reccha		; Wait for a character
		cmp	#$2C
		beq	sic			; it was a delimiter
  		jsr	hexnum		; Read parameter = id
		bmi	sib
  		beq	said
  
sic		lda	inl			; Save id
		sta	id
		cmp	#$00		; Id = 00 & FF are not valid
		beq	sia
  		cmp	#$FF
		beq	sia
  		jsr	resin		; Reset input buffer
		jsr	inpar		; read SA and EA
		bmi	sib			; Not valid character
  		lda	paral		; Save all parameters
		sta	sal
		lda	parah
		sta	sah
		lda	parbl
		sta	eal
		lda	parbh
		sta	eah
		jsr	dump		; Store data on tape
		jsr	restty		; I/O reset
		ldy	#$4C		; "ready"
		jsr	messy		; $11D6
		jsr	crlf		; $11E8
		ldy	#$00		; Normal exit

sib		rts				; $1486		
  
sia		ldy	#$FF		; Error exit
		rts
  
getid	jsr	ipb			; Read id
		bmi	ga			; Not valid parameter
  		sta	id			; Save id
		cmp	#$FF		; Special id
		beq	idpar
  
gb		jsr	rdtape		; read data from tape
		jsr	restty		; I/O reset
		ldy	#$4C		; "ready"
		jsr	messy		; $11D6
		jsr	crlf		; $11E8
		ldy	#$00		; Normal exit
		
ga		rts				; $14a6
  
idpar	ldy	#$5C		; " SA "
		jsr	messy		; $11D6
		jsr	ipbres		; read a special id
		bmi	ga			; Not valid parameter
  		sta	sal			; save start addres
		lda	inh
		sta	sah
		jmp	gb			; $1496
  
restty	lda	#$67		; $14bc
		sta	pbd
		lda	#$00
		sta	pad
		lda	#$7F
		sta	padd
		sta	pbdd
		rts
		
		; STEP BY STEP PROGRAM OF THE PRINTER MONITOR
		
		; the NMI vector for step by step is set automatically
		; Step switch: on position
		; K4 and K5 disable the sync signal of the processor
		; a hardware modification is r.equired (see book 3)

step	sta acc			; Save accu
		pla				; Get Preg
		sta	preg
		pla				; Get PCL
		sta	pcl
		sta	pointl		; PC of the next instruction
		pla				; Get PCH
		sta	pch
		sta	pointh
		sty	yreg
		stx	xreg
		tsx				; Get old stack pointer
		stx	spuser		; and save it
		jsr	prbufs		; Open next cell
		jmp	resall		; Back to monitor
		
		; SPECIAL ID
  
ipbres	lda	#$00		; $14ED
		sta	inl			; Reset input buffer
		sta	inh
		jmp	ipb			; Continue

		; END OF PROGRAM  
 
.end				; End of part to assemble
		